package com.link.core.mybatis;

import com.link.core.util.SpringUtil;
import java.io.IOException;
import org.apache.http.Consts;
import org.apache.ibatis.builder.xml.XMLMapperBuilder;
import org.apache.ibatis.session.Configuration;
import org.apache.ibatis.session.SqlSessionFactory;
import org.springframework.core.io.ByteArrayResource;
import org.springframework.core.io.Resource;

public class XMLMapperLoader {
   public static Resource parseAndBindXml(String daoXmlContent, String description) throws IOException {
      byte[] daoXml = daoXmlContent.getBytes(Consts.UTF_8);
      ByteArrayResource resource = new ByteArrayResource(daoXml, description);
      parseAndBindXml(resource);
      return resource;
   }

   public static void parseAndBindXml(Resource xmlMapper) throws IOException {
      SqlSessionFactory sqlSessionFactory = (SqlSessionFactory)SpringUtil.getBean(SqlSessionFactory.class);
      Configuration configuration = sqlSessionFactory.getConfiguration();
      XMLMapperBuilder mapperParser = new XMLMapperBuilder(xmlMapper.getInputStream(), configuration, xmlMapper.toString(), configuration.getSqlFragments());
      mapperParser.parse();
   }
}
